// File: OneOnly.java
// Show that only one process may be active in any synchronized
//	method of an object

class Shared {

 public synchronized void one()
 { System.out.println("One starts and will sleep 5 seconds");
   try {
     Thread.sleep(5000);
   }
   catch (Exception e) {
     System.out.println(e);
   }
   System.out.println("One wakes up");
 }

 public synchronized void two()
 { System.out.println("Two starts");
 }

}

class TestOneOnly extends Thread {

 Shared Share;
 Thread T=new Thread(this);

 public void run() 
 { 
   try {
     Thread.sleep(50);
   }
   catch (Exception e) {
     System.out.println(e);
   }
   System.out.println("Caling two");
   Share.two();
 }

 void start2()
 {  T.start();
 }

 public void main()
 { Share=new Shared();
   start2();
   Share.one();
 }
}

public class OneOnly {
 
  public static void main(String args[])
  { TestOneOnly TO=new TestOneOnly();
    TO.main();
  }
} // class
